<?php
class EMS {

	public static $media;
	public static $page;
	public static $nav;
	public static $results;
	public static $section;
	public static $message;
	public static $error;
	
	public function __construct() { }

	public function error( $type_id = 0, $info = false ){
		switch($type_id) {
			case 1:
			if($info) { 
				EMS::$error = $info;
			} else {
				//EMS::$error = "One of more tables are missing, please run the 'Update Database' option in the system area.";
			}
			break;
			
			
		}
	}

	public function domain()
	{
		if(defined('SITE_URL')) {
			return rtrim(SITE_URL,'/') . '/';
		} else {
			return "http://" . rtrim(strip_tags( $_SERVER[ "SERVER_NAME" ] . DOC_ROOT ),'/') . '/';
		}
	}
	
	public function domain_root() 
	{
		return strip_tags( $_SERVER[ "SERVER_NAME" ]); 
	}
	
	public function domain_full() {
		if($_SERVER['QUERY_STRING']) { $query = '?' . $_SERVER['QUERY_STRING']; }
		return "http://" . rtrim(strip_tags( $_SERVER[ "SERVER_NAME" ] . DOC_ROOT ),'/') . $_SERVER['PHP_SELF'] . $query;
	}
	
	public function login() {
		?>
		<script type="text/javascript">
			function ems_login() { 
				window.open('<?php echo EMS::login_link()?>&popup=true', "ems_user_login", "width=550,height=450,scrollbars=yes");
				return false;
			}
		</script>
		<?php
	}
	
	public function login_link() {
		return "http://easymediascript.com/remote/user_login?return=".urlencode(EMS::currentURL())."&domain=".urlencode(EMS::domain())."&key=".Options::$option['site_key']."&token=".Session::token();
	}
	
	public function signup_link() {
		return EMS::login_link() . "&signup=true";
	}
	
	public function site_sync() {
		if(Options::$option['abs_path'] > 0) {
			$fullsize_path =  Options::$option['folder_image_url'];
			$thumbnail_path = Options::$option['folder_thumb_url'];
		} else {
			$fullsize_path =  EMS::domain() . Options::$option['folder_image'];
			$thumbnail_path = EMS::domain() . Options::$option['folder_thumb'];
		}
		$params['site_key'] = EMS::sitekey(); //required
		$params['site_name'] = urlencode(Options::$option['site_name']);
		$params['thumbnail_path'] = urlencode($thumbnail_path);
		$params['fullsize_path'] = urlencode($fullsize_path);
		$params['site_url'] = urlencode(EMS::domain());
		$params['publisher_key'] = Options::$option['secret_key']; //required
		EMS::curl('http://easymediascript.com/remote/site_sync',false,$params);
	}
	
	public function init() {

	Navigation::init();
	
	$ems_nav = Navigation::$go;
	$ems_nav['current'] = $_GET['section'];

	$ems_page = array();
	$ems_page['current'] = $_GET['page']; 
	if(!$ems_page['current'] && $ems_nav['current'] != 'home') { $ems_page['current'] = 1; }
	
	
	EMS::$page = $ems_page;
	EMS::$nav = $ems_nav;
	EMS::$section = $_GET['section'];
	} // end init()
	
	
	public function get_type_id($type) {
		switch($type) {
			case "image":
			$type_id = '0';
			break;
			case "images":
			$type_id = '0';
			break;
		
			case "video":
			$type_id = '1';
			break;
			case "videos":
			$type_id = '1';
			break;
			
			case "flash":
			$type_id = '2';
			break;
			
			case "mixed":
			$type_id = '99';
			break;
		}
		return $type_id;
	}
	
	
	public function url_encode_chars($string) {
		$string = str_replace("#", "No.", $string);
		$string = str_replace("$", "Dollar", $string);
		$string = str_replace("%", "Percent", $string);
		$string = str_replace("^", "", $string);
		$string = str_replace("&", "and", $string);
		$string = str_replace("*", "", $string);
		$string = str_replace("?", "", $string);
		return $string;
	}
	
	public function find($what,$string) {
		preg_match('#'.$what.'#',$what,$match);
		if($match) {
		return true;
		}
	}

	public function start($char,$string) {
	  if(substr($string,0,1) == $char) { return true; }
	}
	
	// escape function
	public function e($string) { 
	if(get_magic_quotes_runtime()) $string = stripslashes($string);
		return @mysql_real_escape_string($string);
	}
	
	
	public function starts_with($char,$string) {
		$check = substr($string,1);
		if($check == $char) { return true; } 
	}
	
	// get extension (.gif, .jpg, .png) etc...
	public function extension($filename) {
		$ext = strrchr( $filename , "." );
		return $ext; // starts with a period
	}
	
	public function getSubclasses($parentClassName)
	{
	    $classes = array();
	    foreach (get_declared_classes() as $className)
	    {
	    	if (is_subclass_of($className, $parentClassName))
	    		$classes[] = $className;
	    }
	
	    return $classes;
	}
	
	public function ajax() { 
		if(strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') { return true; }
	}
	
	
	// get basename of file (function basename is already being used in PHP)
	public function filename($file, $via_path = false) {
		if($via_path) {
			$info = pathinfo($file);
			$file_name =  basename($file,'.'.$info['extension']);
		} else {		
			if(EMS::extension($file)) {
				$file_name_array = explode(EMS::extension($file),$file);
				$file_name = $file_name_array[0];
			} else {
				$file_name = $file;
			}
		}
		if(!$file_name) { $file_name = time(); }
		
		return EMS::clean_url($file_name);
	}
	
	
	public function is_ajax() {
		if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest' || $_POST['js']) { return true; }
	}
	
	public function cleanup() {
		if(Options::$option['demo'] == 1) { 
			Media::removeAll();
		}
	}
	
	// alert message
	function alert($type,$msg,$location=false) { 

	if(EMS::is_ajax()) {
	  $results['message'] = $msg;
	  $results['message_type'] = $type;
	  echo json_encode($results);
	  die($content);
	}
	
	$_SESSION['message'] = $msg;
	$_SESSION['message_type'] = $type;
	$smarty = Template::$smarty;
	if($location) { 
		header('Location: '.$location);  return; 
	} else { 
		$message[$type] = $msg;
		$error = true; 
		Template::$message = $msg;
		Template::$message_type = $type;
			if($smarty) {
				$smarty->assign('message',$msg);
				$smarty->assign('message_type',$type);
			}
			unset($_SESSION['message']);
			unset($_SESSION['message_type']);
		}
	}
	
	
	public function assign_sitekey(){ 
		MYSQL_QUERY("REPLACE INTO ip_options(name,namespace,val) VALUES('Site Key','site_key','".EMS::sitekey()."')") or NULL;
	}
	
	public function sitekey() {
		return md5( EMS::domain_root() . trim(DOC_ROOT,'/') );
	}
	
	public function site_count($type_id = 0) {
		$query = MYSQL_QUERY("SELECT i FROM ip_media");
		$count = MYSQL_NUM_ROWS($query);
		if($type_id == 0) { $namespace = "total_images"; }
		if($type_id == 1) { $namespace = "total_videos"; }
		if($type_id == 2) { $namespace = "total_flash"; }
		MYSQL_QUERY("UPDATE ip_sitestats SET val = '".$count."' WHERE namespace = '".$namespace."'");
	}
	
	
	public function rename_file($media,$rename) {
	
		if(!$media['id']) { return; }
		
		$select = MYSQL_QUERY("SELECT filename,folder FROM `ip_media` WHERE i = '".$media['id']."'");
		while($s = MYSQL_FETCH_ASSOC($select)) { $media['filename'] = $s['filename']; $folder = ""; if($s['folder']) { $folder = $s['folder'] . "/"; }  }
		
		if($media['id'] && $media['filename']) {
				$image_details = Database::sql_row('images','WHERE i = "'.$media['id'].'"','filename');
				$filename_count = false;
				$rename = EMS::clean_url(EMS::filename($rename));
				$rename_ext = EMS::extension($media['filename']);
				while(true) {
					$check = MYSQL_QUERY("SELECT i FROM ip_media WHERE filename = '".$rename.$filename_count.$rename_ext."' AND i != '".$media['id']."'");
					$count = MYSQL_NUM_ROWS($check);
					if($count == 0) { 
						$rename_set = $rename . $filename_count . $rename_ext; 
						if(file_exists(Options::$site['full']['path'] . $folder . $media['filename'])) { 
							rename(Options::$site['full']['path'] . $folder . $media['filename'], Options::$site['full']['path'] . $folder . $rename_set); 
						}
						if(file_exists(Options::$site['thumb']['path'] . $folder . $media['filename'])) {
							rename(Options::$site['thumb']['path'] . $folder . $media['filename'], Options::$site['thumb']['path'] . $folder . $rename_set);
						}
						break;
					} else { 
						if(!$filename_count) { $filename_count = 0; } 
						$filename_count++; 
					}
				}
				if($rename_set) {
					MYSQL_QUERY("UPDATE ip_media SET filename = '".$rename_set."', thumbnail = '".$rename_set."' WHERE i = '".$media['id']."'");
				}
			}
			//echo "UPDATE ip_media SET filename = '".$rename_set."' WHERE i = '".$media['id']."'";
	}
	
		
	public function checkUrl($media,$url) { // used to make sure no duplicate urls exist
		$url = EMS::clean_url($url);
		while(true) {
			$select = MYSQL_QUERY("SELECT i FROM ip_media WHERE url = '".$url.$counter."' AND i != '".$media['id']."'");
			$count = MYSQL_NUM_ROWS($select);
			if($count == 0) { 
				return $url.$counter; 
				break; 
			} else { 
				if(!$counter) { 
					$counter = 0; 
				} 
				$counter++; 
			} //end count
		}//end while
	}//end checkUrl function

	
	
	// add stripslashes to anything
	public function ss($string) { //strips slashes for variables and arrays
		if(is_array($string)) { 
			foreach($string as $stringID => $stringValue) { $string[$stringID] = stripslashes($stringValue); } return $string;
		} else {
			return stripslashes($string);
		}
	}


	//prevents sql injections
	public function cleanPost($value) {
	if(count($value) > 0) { foreach($value as $arrayID => $arrayValue) { $return[$arrayID] = EMS::e($arrayValue); } } else { $return = EMS::e($value); }
	return $return;
	}
	
	
	
	function createFolder($folder) {
		if(!file_exists(ROOT . $folder)) { mkdir(ROOT. $folder. '/', 0777); }
	}

	function toBytes($str){
        $val = trim($str);
        $last = strtolower($str[strlen($str)-1]);
        switch($last) {
            case 'g': $val *= 1024;
            case 'm': $val *= 1024;
            case 'k': $val *= 1024;        
        }
        return $val;
       }

	function bytes($bytes) 
    {
    $size = $bytes / 1024;
    if($size < 1024)
        {
        $size = number_format($size, 2);
        $size .= ' KB';
        } 
    else 
        {
        if($size / 1024 < 1024) 
            {
            $size = number_format($size / 1024, 2);
            $size .= ' MB';
            } 
        else if ($size / 1024 / 1024 < 1024)  
            {
            $size = number_format($size / 1024 / 1024, 2);
            $size .= ' GB';
            } 
        }
    return $size;
    } 

	
	function clean_ad_url($text)
	{
	$text=trim($text);
	$text=strtolower($text);
	$text=str_replace(' ','_',$text);
	    $RemoveChars  = array( "([^a-zA-Z0-9_])" );
	    $ReplaceWith = array( "");
	    return preg_replace($RemoveChars, $ReplaceWith, $text);
	} 
	
	
	function clean_category($text)
	{
	$text=trim($text);
	$text=str_replace(' ','_',$text);
	    $RemoveChars  = array( "([^a-zA-Z0-9_])" );
	    $ReplaceWith = array( "");
	    return preg_replace($RemoveChars, $ReplaceWith, $text);
	} 
	
	function formatDomain($url) {
		preg_match('#http://(.*?)/#',$url,$urlmatch);
		if(!$urlmatch) { preg_match('#http://(.*?)#',$url,$urlmatch); }
			if($urlmatch) { 
				return $urlmatch[1];
			} else { 
				return $url; 
			}
	}
	
	
	function isValid($str) {
	    return !preg_match('/[^A-Za-z0-9.#\\-$]/', $str);
	}
	
	// clean bad characters only
	function clean( $Raw ){
	    $Raw = trim($Raw);
	    $RemoveChars  = array( "([^a-zA-Z0-9-_: ])" );
	    $ReplaceWith = array( "");
	    return preg_replace($RemoveChars, $ReplaceWith, $Raw);
	} 
	
	
	
	function get_username($id) {
	if(is_numeric($id)) {
		$username = sql_row('users','WHERE id = "'.$id.'"','user');
		return $username['user'];
	}
	}//end function getUsername


	public function stats() {
		$statsSelect = MYSQL_QUERY("SELECT * FROM ip_sitestats") or false;
		if($statsSelect) {
		while($s = MYSQL_FETCH_ARRAY($statsSelect)) { $siteStats[$s['namespace']] = $s['val']; }
		if(!$siteStats['version']) { MYSQL_QUERY("INSERT INTO ip_sitestats(name,namespace,val) VALUES('Version','version','$script[version]')"); }
		return $siteStats;
		}
	}

	
	public function checkMatch($array) {
	foreach($array as $matchID => $match) { 
		if($match) { 
			$ext = ltrim(strtoupper(strrchr( $match , "." )),'.'); 
			if($ext == 'JPG' || $ext == 'GIF' || $ext == 'PNG' || $ext == 'JPEG') { 
				$imageArray[] = $match; 
			} 
			$ext = false; 
		} 
	}
	return $imageArray;
	}//end function




	function call($url = false)
	{
	global $generateKey;
	if(!$url) { $url = "http://easymediascript.com/checkupdate.php"; }
	
	$postdata = http_build_query(
	    array(
	        'key' => $generateKey,
	        'url' => urlencode(EMS::domain())
	    )
	);
	
	$opts = array(
	  'http'=>array(
	    'method'=>"POST",
	    'header'=>"Accept-language: en\r\n" .
	             "Referer: ".$_SERVER['HTTP_HOST']."\r\n".
	             "Content-type: application/x-www-form-urlencoded\r\n",
	    'content' => $postdata
	  )
	);
	$context = stream_context_create($opts);

	  if( ini_get( 'allow_url_fopen' ) == '1' )
	  {
	    return file_get_contents( $url, false, $context ) or null;
	  }
	  
	}
	
	
	public function currentURL() {
	
	 $pageURL = 'http';
	 if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";}
	 $pageURL .= "://";
	 if ($_SERVER["SERVER_PORT"] != "80") {
	  $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
	 } else {
	  $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
	 }
	 return $pageURL;
 
 }
	
	
	
	public function curl($curl_location,$curl_cookie = false, $curl_params = false) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $curl_location);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR 1.0.3705; .NET CLR 1.1.4322; Media Center PC 4.0)');
		if($curl_params) {
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $curl_params);
		}
		if($curl_cookie) {
		$cookie = ROOT.'ip-inc/tmp/'.$curl_cookie.'.txt';
		curl_setopt ($ch, CURLOPT_COOKIEJAR, $cookie);
		curl_setopt ($ch, CURLOPT_COOKIEFILE, $cookie); 
		}
		$output = curl_exec ($ch);
		curl_close($ch);
		return $output;
	} //end curl function
	
	
	function cleanFolder($folder) {
		$allowed = "/(^[a-zA-Z0-9-_]+)/";
		preg_match($allowed,$folder,$found);
		if($found) {
			return true;
		}
	}			
	
	
	function clean_url($text,$replaceChar=false,$disableLowercase=false)
	{
	$text=trim($text);
	if(!$disableLowercase) { $text=strtolower($text); }
	if(!$replaceChar) { $replaceChar = '-'; }
	$text=str_replace(' ',$replaceChar,$text);
	    $RemoveChars  = array( "([^a-zA-Z0-9-_.])" );
	    $ReplaceWith = array( "");
	    return preg_replace($RemoveChars, $ReplaceWith, $text);
	} 




	function help($message) {
		echo "<img src=\"img/icons/question.png\" title=\"".$message."\" class=\"tip\" />";
	}
	
	
	
	function version() {
		$select = Database::sql_row('sitestats','WHERE namespace = "version"');
		return $select['val'];
	}
	
	
	function check_version($current_version = false)
	{
	if($current_version) {
		$site_version = EMS::curl('http://easymediascript.com/checkversion.php');
		if($site_version > $current_version) {
			return true;
		}
	}
	}//end function check_version


	

	function cleanArray($array) { //removes empty arrays
		if(is_array($array)) { 
			foreach($array as $arrayID => $arrayValue) {
				if(!$arrayValue) {
					unset($array[$arrayID]);
				} 
			}
		}
		return $array;
	}




	public function likeButton() {
		global $nav;
		global $media;
		global $smarty;
		$like = '<iframe src="http://www.facebook.com/plugins/like.php?href='.urlencode(EMS::domain() . $nav['location'] . $media['url']).'&amp;layout=box_count&amp;show_faces=true&amp;width=200&amp;action=like&amp;colorscheme=light&amp;height=65" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:200px; height:65px;" allowTransparency="true"></iframe>';
		if($smarty) { $smarty->assign('like',$like); }
	}
	
	public function ip() {
		return isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
	}


	public function trimQuery($string) {
		$string = str_replace('/','',$string);
		$string = str_replace('?','',$string);
		return $string;
	}
	
	
	public function check() {
		$select = MYSQL_QUERY("SELECT name FROM ip_template") or null;
		if($select) {
			return true;
		} else {
			 header('Location: ' . DOC_ROOT . "ip-admin/maintenance.php"); 
			 exit; 
		}
	}


}