<?php
define(APP_PATH, ROOT . 'ip-inc/');

// make tmp folder if none exists
if (!file_exists(APP_PATH . 'tmp/')) { mkdir(APP_PATH . 'tmp/'); }

require(APP_PATH . 'classes/Autoloader.class.php');
Autoloader::setCacheFilePath(APP_PATH . 'tmp/class_path_cache.txt');
Autoloader::excludeFolderNamesMatchingRegex('/^CVS|\..*$/');
Autoloader::setClassPaths(array(
    APP_PATH . 'classes/',
    APP_PATH . 'lib/'
    
));

require ROOT . 'ip-inc/lib/class-xhttp-php/class.xhttp.php'; 

// make template cache folder
if (!file_exists(ROOT . 'ip-templates_c/')) { mkdir(ROOT . 'ip-templates_c/'); }


// register Autoloader
spl_autoload_register(array('Autoloader', 'loadClass'));

if(!$disable_session) {
	Session::init();
	if(!$ems_disable_token) {
		Session::token();
	}
}

$ems_connect = Database::init();

if($ems_connect) {
	Options::init();
	
	EMS::init();
	Pages::init();
	Session::tracking();
	
	Ads::display();
	
	Template::init();
	Template::smarty();
	Template::assign();
	
	Tags::cloud();
}

include_once ROOT."ip-inc/functions.php";

if(!$disable_redirect) {
	Redirect::init();
}