<?php
// name
$name = "Twitpic";

// requirements 
// can be either a direct description, or can be added in an array (name => name,description => value)
// 
//*
$requirements['api_key'] = array('name' => 'API Key', 'description' => 'your TwitPic API key (http://dev.twitpic.com/apps)'); 
$requirements['consumer_token'] = array('name' => 'Consumer Key', 'description' => 'your Twitter application consumer key');
$requirements['consumer_secret'] = array('name' => 'Consumer Secret');
$requirements['message'] = array('name' => 'Default Message');

$requirements['oauth'] = array('hidden' => true);

$requestTokenURL = 'https://api.twitter.com/oauth/request_token';
$authorizeURL    = 'https://api.twitter.com/oauth/authorize';
$accessTokenURL  = 'https://api.twitter.com/oauth/access_token';

$callbackURL     = $_SESSION['callback']; # Change this to the URL of this script

if($l['consumer_token'] && $l['consumer_secret']) {

xhttp::load('profile,oauth');
$twitpic = new xhttp_profile();
$twitpic->oauth($l['consumer_token'], $l['consumer_secret'], $l['oauth_token'], $l['oauth_token_secret']);

if($oauth_verify) {

$twitpic->oauth_method('get'); // For compatability, OAuth values are sent as GET data

    # STEP 2: Application gets a Request Token from twitpic
    $data = array();
    $data['post']['oauth_callback'] = $callbackURL;
    $response = $twitpic->fetch($requestTokenURL, $data);

    if($response['successful']) {
        $var = xhttp::toQueryArray($response['body']);
        $_SESSION['oauth_token']        = $var['oauth_token'];
        $_SESSION['oauth_token_secret'] = $var['oauth_token_secret'];
        Autopost::$success = true;

        # STEP 3: Application redirects the user to twitpic for authorization.
        header('Location: '.$authorizeURL.'?oauth_token='.$_SESSION['oauth_token'], true, 303);
        die();
		# STEP 4: (Hidden from Application)
		# User gets redirected to twitpic.
		# twitpic asks if she wants to allow the application to have access to her account.
		# She clicks on the "Allow" button.

    } else {
       Autopost::$error = 'Could not get token. Response from server: ' . $response['body'];
    }


}


if($oauth_callback) {

$twitpic->oauth_method('get'); // For compatability, OAuth values are sent as GET data

    $data = array();
    $data['post']['oauth_verifier'] = $_GET['oauth_verifier'];

    $twitpic->set_token($_SESSION['oauth_token'], $_SESSION['oauth_token_secret']);
    $response = $twitpic->fetch($accessTokenURL, $data);

    if($response['successful']) {

	    # STEP 7: Application now has access to the user's data,
	    # for reading protected entries, sending a post updates.
        $var = xhttp::toQueryArray($response['body']);

        Autopost::$success = true;
        $results['form']['oauth_token'] = $var['oauth_token'];
        $results['form']['oauth_token_secret'] = $var['oauth_token_secret'];

    } else {
    	Autopost::$error = 'Unable to sign in. Response from server: ' . $response['body'];
    }


}



// $run = true when running autopost

if($run) {

	if($media['title']) { $l['message'] = $media['title']; }
	if(!$l['message']) { $l['message'] = "Photo"; }


// Generate OAuth Header
$authorization = $twitpic->get_oauth_header('https://api.twitter.com/1/account/verify_credentials.json');


$data = array();
$data['headers'] = array(
	'X-Auth-Service-Provider' => 'https://api.twitter.com/1/account/verify_credentials.json',
	'X-Verify-Credentials-Authorization' => $authorization,
	);

$data['post'] = array(
	'key'    => $l['api_key'],  # Twitpic App API key
	'message'=> $l['message'],      # Twitter status
	);
	
$data['files'] = array(
	'media'  => Options::$site['full']['url'] . $media['filename'],
);
	
$response = xhttp::fetch('http://api.twitpic.com/2/upload.xml', $data);

if($response['successful']) {
	echo $response['body'];
} else {
	print_r($response);		
}

exit;
}

}